<?php
 	ini_set('display_errors', 0);

	//=== site map keys === (using same name for now, but should probably use integers in future)
	/* may not have to be globals, but members of the Contentigo object... */ 
	define('CSM_ENVIRONMENT','ENVIRONMENT');
	define('CSM_ROOT','ROOT');
	
	define('CSM_DEFAULT_TIMEZONE','DEFAULT_TIMEZONE');	//value as specified here: http://www.php.net/manual/en/timezones.php
	define('CSM_LOCALE_DEFAULT','DEFAULT_LOCALE');
	define('CSM_LOCALE_PARAMETER_NAME','LOCALE_URL_PARAMETER');

	define('CSM_DEFAULT_TEMPLATE','DEFAULT_TEMPLATE');
	define('CSM_DEFAULT_RESPONSE_TYPE','DEFAULT_RESPONSE_TYPE');
	define('CSM_PREPROCESSOR_ACTIONS','PREPROCESSOR_ACTIONS');
	
	define('CSM_RESOURCE_CACHING','RESOURCE_CACHING');
	define('CSM_RESOURCE_CACHE_DAYS','RESOURCE_CACHE_DAYS');
	define('CSM_CONTENT_CACHING','CONTENT_CACHING');

	define('CSM_GLOBAL_BLOCKS','GLOBAL_BLOCKS');
	
	define('CSM_TEMPLATE_BLOCKS','TEMPLATE_BLOCKS');
	define('CSM_URL_CONTENT_MAP','URL_CONTENT_MAP');
		//cdef: 'blocks', 'actions', 'response_type', 'template'
	define('CSM_ZONES', 'ZONES');
	define('CSM_AUTHENTICATION', 'CSM_AUTHENTICATION');
		//define('ACCESS_SESSION_KEY', 'ACCESS_SESSION_KEY');

	define('CSM_ACTION_RESPONSE_MAP', 'ACTION_RESPONSE_MAP');

	//related to resource handling, could be defined in the resource handler script...
	define('CSM_SCRIPT_SETS', 'CSM_SCRIPT_SETS');
	define('CSM_SCRIPT_SET_CACHING', 'SCRIPT_SET_CACHING');

	define('CSM_CSS_SETS', 'CSM_CSS_SETS');
	define('CSM_CSS_SET_CACHING', 'CSS_SET_CACHING');

	define('CSM_DEBUG', 'DEBUG');
	
	define('CSM_DEBUG_EMAILS', 'CSM_DEBUG_EMAILS');
	define('CSM_DEBUG_EMAIL_DIRECTORY', 'CSM_DEBUG_EMAIL_DIRECTORY');
	define('CSM_DEBUG_SEND_EMAILS', 'CSM_DEBUG_SEND_EMAILS');

	
	//suggest:
	//	'synchronized' actions, implement a 'synchronized' interface
	//	$site[CSM_CORE_MODULES] = array('Database', 'Email')
	//	$site[CSM_SITE_MODULES] = array('Foo', 'Bar')
	//  $site[CSM_ZONE_TEMPLATES] - defined default template for site zones
	
	//===================


	//response modes:
	define('TEMPLATE', 1);		//standard URL response (a full page)
	define('SINGLE_BLOCK', 2);	//from the result of an action
	define('RAW', 3);			//from the result of an action
	define('DOWNLOAD', 4);			//from the result of an action

	define('APPLICATION_CONTENT', 1);			//from the result of an action

	//for backwards compatibility - the new way is to use $CONTENTIGO_HOME, so
	//if it is set, set the old '$CONTENTIGO_LOCATION' to the same value 
	if( isset( $CONTENTIGO_HOME) ) {
		$CONTENTIGO_LOCATION = $CONTENTIGO_HOME;
	} else {
		//and for forward compatitbility! now we can safely use the new $CONTENTIGO_HOME
		$CONTENTIGO_HOME = $CONTENTIGO_LOCATION;
	}

//	require_once( $CONTENTIGO_LOCATION . '/contentigo.config.php');

	//do we HAVE to do this ????
	require_once( $CONTENTIGO_LOCATION . '/lib/utils.php');

	//standard environments
	/*
	define('DEVELOPMENT', 1);
	define('STAGING', 2);
	define('PRODUCTION', 3);*/

/*
	1. Keep site config file (at least file location config) outside 'site' directory, so we can have 
	different configs for different environments (local, dev, live etc) 

	2. How to put a block inside a block?

	3. If we can - what is the difference between a block and a template?
	
	4. try to design it in a 'chain' pattern. collect all the data you need, then 'compile' and return response:
		'template' 'block' 'resource' 'cache'
 
 	5. Should be able to be mono-locale: $site['DEFAULT_LOCALE'] = null, so only looks for 'global' filenames
 	
 	6. ERROR handling!
 			- check for .tpls that dont exists: "Smarty error: unable to read resource:""
			- configurable error messages for invalid/unconfigured URLs
			- default page for unconfigured URL's?
	
	7. implement handling of: $site['TEMPLATE_BLOCKS'] (blocks loaded by default for each template)
	
*/

	$contentigo = null;
	
	$ENVIRONMENT = array();


	$requestPath = null;
	$pathParts = null;
	$cdef = null;
	$dataCollector = null;

	$modules = array();	//maintain list of loaded modules, so not loaded twice

	class Contentigo {

		private $smarty = null;

		function Contentigo() {
		}
		
		function go() {

			global $site;

			global $CONTENTIGO_LOCATION;
			global $CONTENTIGO_HOME;
			global $SITE_LOCATION;
			global $URL_RESOURCE_MAP;
			global $SIMPLE_RESOURCE_TYPES;
			global $EXTENSION_CONTENT_TYPE_MAP;
			global $ENVIRONMENT;

//			chdir( $SITE_LOCATION);

			//overwrite $site setting with environment $site.php
			$environmentSiteFile = $SITE_LOCATION . '/environments/' . $site[CSM_ENVIRONMENT] . '/site.php';
			if( file_exists( $environmentSiteFile) ) {
				require_once( $environmentSiteFile);
			}


			if( isset( $site[CSM_ROOT]) && !empty( $site[CSM_ROOT]) ) {
				
			} else {
				$site[CSM_ROOT] = '/';
			}
			$siteData['root'] = $site[CSM_ROOT];
//			$siteData['server'] = $site['SERVER'];

			global $pathParts;
			global $requestPath;

			$requestPath = $_REQUEST['path'];
			if( strlen( $requestPath) > 0 ) {
				$requestPath = rtrim( $requestPath, '/');
				$pathParts = explode( '/', $requestPath);
				$pathDepth = count( $pathParts);
				array_unshift( $pathParts, '/');
			} else {
				$requestPath = '';
				$pathParts = array('/');
				$pathDepth = 0;
			}

			if( isset( $site[CSM_DEFAULT_TIMEZONE] ) ) {
				date_default_timezone_set( $site[CSM_DEFAULT_TIMEZONE] );
			}

			//debugVarDump( $site, false);

			//only do this if/when we need the session because it locks the script until it finishes:
			session_start();

			//====== CHECK FOR ACTIONS FIRST - we may not need templates (returning JSON etc)



			//======= INIT SMARTY TEMPLATES ======
			require_once( $CONTENTIGO_HOME . '/lib/Smarty-2.6.26/libs/Smarty.class.php');
			$this->smarty = new Smarty();
			
			//assign templates_c directory to smarty
			$compiledTemplateDir = $SITE_LOCATION . '/_cache/templates_c';
			if( !file_exists( $compiledTemplateDir) ) {
				$createCompiledTemplateDirSuccess = mkdir( $compiledTemplateDir, 0777, true);
				if( $createCompiledTemplateDirSuccess) {
					//echo 'created susces';
				} else {
					//echo 'noooo';
				}
			}
			$this->smarty->compile_dir = $compiledTemplateDir;

			//$smarty->caching = 1;

			//===== Environment variables to smarty:
			
//			$siteData['name'] = $site['NAME'];
		  	$this->smarty->assign('site', $siteData);


			if( $pathDepth > 0) {
				require_once( $CONTENTIGO_HOME . '/resources.config.php');
				//check to see if url is defined in resources:
				if( isset( $URL_RESOURCE_MAP[ $pathParts[1] ]) ) {
					
					//yes, our url is a resource:
					//$resourceTypeDef = $URL_RESOURCE_MAP[ $pathParts[0] ];
					
					require_once( $CONTENTIGO_HOME . '/resource_handler.php');
					$resourceHandler = new ResourceHandler();
					$resourceHandler->serveSpecificResource( $site, $pathParts, $pathDepth, $this->smarty);
					exit;
				}
				
				if( isset( $SIMPLE_RESOURCE_TYPES[ $pathParts[1] ] ) ) {
					require_once( $CONTENTIGO_HOME . '/resource_handler.php');
					$resourceHandler = new ResourceHandler();
					$resourceHandler->serveGeneralResource( $site, $pathParts, $pathDepth, $this->smarty);
					exit;
				}
				
			}

			
			$usingZones = false;
			$usingZoneTemplate = false;
			
			if( isset( $site[CSM_ZONES]) && !empty( $site[CSM_ZONES])) {
				$usingZones = true;
				//confirm session zones list exists:
				if( !isset( $_SESSION[CSM_ZONES])) {
					$_SESSION[CSM_ZONES] = array();
				}
			}			


			//needs to be cleverer than this.
			//needs to be a loop, that finds the most specific 
			// 'handler':
			global $cdef;
			$cdef = null;
			$testString = null;
			for ( $i = 0, $max_count = sizeof( $pathParts); $i < $max_count; $i++) {

				if( 0 === $i) {
					$testString = $pathParts[ $i];
				} elseif( 1 === $i){
					$testString .= $pathParts[ $i];
				} else {
					$testString .= '/' .$pathParts[ $i];
				}
				
				if( $usingZones) {
					if( isset( $site[CSM_ZONES][$testString] ) ) {
						$zoneDef = $site[CSM_ZONES][$testString];
						
						//check if 'SERVER_RESTRICTED' - only allow request if originated from this machine
						if( array_key_exists('SERVER_RESTRICTED', $zoneDef) && true === $zoneDef['SERVER_RESTRICTED']) {

							if( $_SERVER['SERVER_ADDR'] !== $_SERVER['REMOTE_ADDR'] ) {
								//oops, request did not come from this machine:
								header('HTTP/1.0 403 Forbidden');
								print('<html><body>HTTP 403 - Forbidden</body></html>');
								exit;
							}
						}

						//check session for ACCESS_SESSION_KEY:
						if( array_key_exists('ACCESS_SESSION_KEY', $zoneDef) && !empty( $zoneDef['ACCESS_SESSION_KEY']) ) {
							
							$zoneAccessKeyName = $zoneDef['ACCESS_SESSION_KEY'];
							
							if( !isset( $_SESSION[ CSM_ZONES][ $zoneAccessKeyName]) || $_SESSION[ CSM_ZONES][ $zoneAccessKeyName] !== true) {
								//zone key not present in session - NOT authorized
								
								//1. check if we have any CSM_AUTHENTICATION settings to see what we should do here
								if( array_key_exists(CSM_AUTHENTICATION, $site) && !empty( $site[CSM_AUTHENTICATION]) ) {
									$authenticationSessionKey = $site[CSM_AUTHENTICATION][ 'AUTHENTICATION_SESSION_KEY'];
									if( isset( $_SESSION[ $authenticationSessionKey]) && true === $_SESSION[ $authenticationSessionKey]) {
										//ok, user is authenticated, so they are simply not autherized to access this zone,
										//continue to return the 403 below 
									} else {
										//the user is NOT authenticated, check what we should do:
										$redirectOnAuthenticationFailure = $site[CSM_AUTHENTICATION]['REDIRECT_ON_AUTHERIZATION_FAILURE'];
										if( isset( $redirectOnAuthenticationFailure) && true === $redirectOnAuthenticationFailure) {
											//ok, so if user has not been authenticated, redirect to defined url to authenticate them (typically login)
											$authenticationFailureURL = $site[CSM_AUTHENTICATION]['AUTHENTICATION_FAILURE_URL'];
											if( isset( $authenticationFailureURL) && !empty( $authenticationFailureURL) ) {
												
												//store the original URL and request POST data in the session so we can redirect if authorization (after authentication is successful)
												if( !empty( $site[CSM_AUTHENTICATION]['AUTHENTICATION_REDIRECT_URL_KEY']) ) {
													$_SESSION[ $site[CSM_AUTHENTICATION]['AUTHENTICATION_REDIRECT_URL_KEY'] ] = $requestPath;
													$_SESSION[ $site[CSM_AUTHENTICATION]['AUTHENTICATION_REDIRECT_DATA_KEY'] ] = $_GET;	//why not $_REQUEST to include $_POST values?

													//unset the 'path' get parameter that will be present because of the mod_rewrite:
													unset( $_SESSION[ $site[CSM_AUTHENTICATION]['AUTHENTICATION_REDIRECT_DATA_KEY'] ]['path']);
												}
												$_SESSION[ $site[CSM_AUTHENTICATION]['AUTHENTICATION_REDIRECT_FLAG_KEY'] ] = true;

												header('Location: ' . $authenticationFailureURL);
												exit;
											}
											
										}
										
									}
								}
								
								//2. else, return a 403 forbidden
								header('HTTP/1.0 403 Forbidden');
								print('<html><body>HTTP 403 - Forbidden</body></html>');
								exit;
								
							}
							
							//check for other zone stuff like zone templates:
							if( isset( $zoneDef['ZONE_TEMPLATE']) || !empty($zoneDef['ZONE_TEMPLATE'])) {
								$usingZoneTemplate = true;
								$zoneTemplate = $zoneDef['ZONE_TEMPLATE'];
							}

						}
						
					}
				}

				if( !isset( $site[CSM_URL_CONTENT_MAP][ $testString] ) ) {
					//not found:
					//break; - No! keep going and look for specific urls

				} else {
					//cdef found - assign:
					$cdef = $site[CSM_URL_CONTENT_MAP][ $testString];
				}

				//found, but let's go deeper to find a more specific handler:
				//$testString = $testString . '/' . $partPart;
				//$lastHandler = $cdef;
			}

//			debugVarDump( $cdef, true);

			if( !isset( $cdef) ) {
				//URL not found! return a 404 page:
				header("HTTP/1.0 404 Not Found");
				//header($_SERVER["SERVER_PROTOCOL"]." 404 Not Found");
				//header("Status: 404 Not Found");
				echo '<h1>Document not found</h1>';
				exit;
			}


/*			
			if( $smarty->is_cached( $cdef['template'] ) ) {
				echo 'cached!: ' . $cdef['template'];
			    //$smarty->display( $cdef['template']);
			}
*/			


			$responseType = TEMPLATE;
			if( isset( $site[CSM_DEFAULT_RESPONSE_TYPE]) && !empty( $site[CSM_DEFAULT_RESPONSE_TYPE])) {
				$responseType = $site[CSM_DEFAULT_RESPONSE_TYPE];
			}

			if( isset( $cdef['response_type']) && !empty( $cdef['response_type']) ) {
				$responseType = $cdef['response_type'];
			}

			
			// ================ LOCALE HANDLING ================
			$localeParameterDetection = false;
			if( isset( $site[CSM_LOCALE_PARAMETER_NAME]) ) {
				$localeParameterDetection = $site[CSM_LOCALE_PARAMETER_NAME];
			}

			$locale = '';
			if( $localeParameterDetection) {
				
				$localeMayHaveChanged = false;
				if( isset( $site[CSM_LOCALE_PARAMETER_NAME]) && !empty( $site[CSM_LOCALE_PARAMETER_NAME]) ) {
	
					if( isset( $_REQUEST[ $site[CSM_LOCALE_PARAMETER_NAME]]) && !empty($_REQUEST[ $site[CSM_LOCALE_PARAMETER_NAME]]) ) {
						$locale = $_REQUEST[ $site[CSM_LOCALE_PARAMETER_NAME]];
						$localeMayHaveChanged = true;
					} else {
						//use the site default locale: 
						if( isset( $site[CSM_LOCALE_DEFAULT]) && !empty( $site[CSM_LOCALE_DEFAULT]) ) {
							$locale = $site[CSM_LOCALE_DEFAULT];
							$localeMayHaveChanged = true;
						}
						
					}
				}

				if( $localeMayHaveChanged && $locale != $_SESSION['locale'] ) {
					//its changed, overwrite with new value:
					$_SESSION['locale'] = $locale;
				}

			} else {

				//no detection, just set session locale to default locale:
				if( isset( $site[CSM_LOCALE_DEFAULT]) && !empty( $site[CSM_LOCALE_DEFAULT]) ) {
					$_SESSION['locale'] = $site[CSM_LOCALE_DEFAULT];
				} else {
					$_SESSION['locale'] = $locale;	//whatever the default was set to, probably ''
				}
			}
			unset( $locale);
			//use '$_SESSION['locale']' from now on

			// ================ LOCALE HANDLING ================


			//store site, template, block, app content here:
			//pass to actions and smarty context
			
			GLOBAL $dataCollector;
			$dataCollector = array();
			
		
			//why declare all these if they don't all get used?
			//$dataCollector['environment'] = array();
//			$dataCollector['site'] = array();
//			$dataCollector['template'] = array();
			$dataCollector['view'] = array();		//(env), site, template, (blocks)
			//$dataCollector['view']['site_location'] = $SITE_LOCATION;
			//$dataCollector['block'] = array();
			$dataCollector['application'] = array();
			$dataCollector['action'] = array();
			$dataCollector['session'] = array();
			$dataCollector['raw'] = array();


			//load environment data (NOT sent to view/smarty - private, server-side only)
	 		$envDefaults = array(
		 		'server_name' => $_SERVER['SERVER_NAME']
	 		);
			
			$environmentDataFile = getLocaleFileName( $SITE_LOCATION . '/environments/' . $site[CSM_ENVIRONMENT] . '/' . $site[CSM_ENVIRONMENT], $_SESSION['locale'], '.txt');
		 	if( file_exists( $environmentDataFile) ) {
		 		$envJSONData = file_get_contents( $environmentDataFile);
		 		$envData = json_decode( cleanJSONString( $envJSONData), true);
		 		$envData = array_merge( $envDefaults, $envData);
		 		$dataCollector['environment'] = $envData;
		 	} else {
		 		$dataCollector['environment'] = $envDefaults;
		 	}
		 	
			//call PREPROCESSOR_ACTIONS (load ENVIRONMENT data first - could have directory/service info)
			if( isset( $site[CSM_PREPROCESSOR_ACTIONS]) && !empty( $site[CSM_PREPROCESSOR_ACTIONS]) ) {
				foreach ( $site[CSM_PREPROCESSOR_ACTIONS] as $actionName) {
					callAction( $site, $actionName, $pathParts, $dataCollector, $cdef, $requestPath);
				}
			}


			//load site data:
			$siteDataFile = getLocaleFileName( $SITE_LOCATION . '/content/site_content/site', $_SESSION['locale'], '.txt'); 
		 	if( !file_exists( $siteDataFile) ) {
				//site data file does not exist
		 	} else {
		 		$siteJSONData = file_get_contents( $siteDataFile);
		 		$siteData = json_decode( cleanJSONString( $siteJSONData), true);
		 		//$dataCollector['site'] = $siteData;
		 		$dataCollector['view'] = $siteData;
		 	}


			if( isset( $cdef[ APPLICATION_CONTENT]) && !empty( $cdef[ APPLICATION_CONTENT]) ) {
				foreach ( $cdef[ APPLICATION_CONTENT] as $appContent) {
					$appContentParts = explode( '>>>', $appContent);
					$appContentDataName = $appContentParts[0];
       				$data = loadData( $appContentDataName);
					if( 2 === count( $appContentParts) ) {
						//we have a psudonim:
						$dataNamespace = $appContentParts[1]; 
					} else {
						$dataNamespace = $appContent;
					}	
       				$dataCollector['application'][ $dataNamespace] = $data;
				}
			}



			//====== LOAD VIEW DATA ======

			//load template data:
			$templateName = $site[CSM_DEFAULT_TEMPLATE];
			if( isset( $cdef['template']) && !empty( $cdef['template']) ) {
				$templateName = $cdef['template'];
			} else {
				if( $usingZones && $usingZoneTemplate) {
					$templateName = $zoneTemplate;
				}
			}
			
			if( null !== $templateName) {
				
				$templateDataFile = getLocaleFileName( $SITE_LOCATION . '/content/template_content/' . $templateName . '/' . $templateName, $_SESSION['locale'], '.txt');
			 	if( !file_exists( $templateDataFile) ) {
					//template data file does not exist
			 	} else {
			 		$templateJSONData = file_get_contents( $templateDataFile);
			 		$templateViewData = json_decode( cleanJSONString( $templateJSONData), true);
			 		//$dataCollector['template'] = $templateViewData;
			 		//$dataCollector['view'] = $templateViewData;
			 		$dataCollector['view'] = array_merge( $dataCollector['view'], $templateViewData);
			 	}

				//load block data: should block data override site/template data - not sure...
				//*should we do this if we only return a block? I think better not to have global_blocks, but
				//template_blocks.*
				if( isset( $site[CSM_GLOBAL_BLOCKS] ) && !empty( $site[CSM_GLOBAL_BLOCKS] ) ) {
					foreach( $site[CSM_GLOBAL_BLOCKS] as $blockName) {
						
						loadBlock( $blockName, $dataCollector, $cdef);
						/*
						$blockDataFile = getLocaleFileName( $SITE_LOCATION . '/content/block_content/' . $blockName . '/' . $blockName, $site['DEFAULT_LOCALE'], '.txt');
					 	if( !file_exists( $blockDataFile) ) {
							//block data file does not exist
					 	} else {
					 		$blockJSONData = file_get_contents( $blockDataFile);
					 		$blockViewData = json_decode( cleanJSONString( $blockJSONData), true);
						  	$dataCollector['block'][ $blockName] = $blockViewData;
					 	}*/
					}
				}
				
				if( isset( $site[CSM_TEMPLATE_BLOCKS][$templateName] ) && !empty( $site[CSM_TEMPLATE_BLOCKS][$templateName] ) ) {
					foreach( $site[CSM_TEMPLATE_BLOCKS][$templateName] as $blockName) {
						loadBlock( $blockName, $dataCollector, $cdef);
						/*
						$blockNameParts = explode( '>>>', $blockName);
						$blockName = $blockNameParts[0];
						
						$blockDataFile = getLocaleFileName( $SITE_LOCATION . '/content/block_content/' . $blockName . '/' . $blockName, $site['DEFAULT_LOCALE'], '.txt');
					 	if( !file_exists( $blockDataFile) ) {
							//block data file does not exist
					 	} else {
					 		$blockJSONData = file_get_contents( $blockDataFile);
					 		$blockViewData = json_decode( cleanJSONString( $blockJSONData), true);
						  	
							if( 2 === count( $blockNameParts)) {
								//we have a psudonim:
								$blockName = $blockNameParts[1]; 
							}
						  	$dataCollector['block'][ $blockName] = $blockViewData;
					 	}*/
					 	
					}
				}
				
			}	
			
			//===============================

			//call actions AFTER loaded default view data
			if( isset( $cdef['actions']) && is_array( $cdef['actions']) && !empty( $cdef['actions']) ) {
				//handle actions array ...
				foreach( $cdef['actions'] as $actionName) {
					callAction( $site, $actionName, $pathParts, $dataCollector, $cdef, $requestPath);
				}
			}

			//check we are not loading the same data twice from 'GLOBAL_BLOCKS' or TEMPLATE_BLOCKS
			if( isset( $cdef['blocks']) && !empty( $cdef['blocks']) ) {
				foreach( $cdef['blocks'] as $blockName) {
				 	loadBlock( $blockName, $dataCollector, $cdef);
				}
			}

			$dataCollector['session'] = $_SESSION;

			//======= OUTPUT PAGE ======
			// *** ah! we could output:
			/*
				1. full template/page (posible with multiple blocks)
				2. a single block (eg: result of an ajax action)
				3. raw data (eg: json)
			*/
			switch( $responseType) {
				case TEMPLATE:				//LOAD ALL BLOCKS AND TEMPLATE:

					//======= LOAD BLOCK DESIGN ======
					$blocks = array();
					
					//GLOBAL BLOCKS
					if( isset( $site[CSM_GLOBAL_BLOCKS] ) && !empty( $site[CSM_GLOBAL_BLOCKS] ) ) {
						foreach( $site[CSM_GLOBAL_BLOCKS] as $blockName) {
							$blockFile = getLocaleFileName( $SITE_LOCATION . '/design/blocks/' . $blockName . '/' . $blockName, $_SESSION['locale'], '.tpl');
							$blocks[ $blockName] = $blockFile;
						}
					}

					//TEMPLATE BLOCKS
					if( isset( $site[CSM_TEMPLATE_BLOCKS][$templateName] ) && !empty( $site[CSM_TEMPLATE_BLOCKS][$templateName] ) ) {
						foreach( $site[CSM_TEMPLATE_BLOCKS][$templateName] as $blockName) {
							
							$blockNameParts = explode( '>>>', $blockName);
							$blockName = $blockNameParts[0];
							$hasAlias = false;
							if( 2 === count( $blockNameParts)) {
								$hasAlias = true;
								$blockAliasName = $blockNameParts[1];
							}
							
							$blockFile = getLocaleFileName( $SITE_LOCATION . '/design/blocks/' . $blockName . '/' . $blockName, $_SESSION['locale'], '.tpl');
						 	if( file_exists( $blockFile) ) {

								//load block data:
							  	$blockData = loadData( $blockName, 'block');
							  	
								if( $hasAlias) {
									$blocks[ $blockAliasName] = $blockFile;
									$dataCollector['block'][ $blockAliasName] = $blockData;
								} else {
									$blocks[ $blockName] = $blockFile;
									$dataCollector['block'][ $blockName] = $blockData;
								}
							}

						}
						
					}
					
					// WE CAN OUTPUT THE ENTIRE $dataCollector JSON OBJECT AS PHP, and 
					//if 'cacheing enabled', we can bypass everything (except Preprocessor),
					
			  		$this->smarty->assign('data', $dataCollector);
					
					//BLOCKS
					if( isset( $cdef['blocks']) && !empty( $cdef['blocks']) ) {
						foreach( $cdef['blocks'] as $blockName) {
							
							$blockNameParts = explode( '>>>', $blockName);
							$blockName = $blockNameParts[0];
							$hasAlias = false;
							if( 2 === count( $blockNameParts)) {
								$hasAlias = true;
								$blockAliasName = $blockNameParts[1];
							}
							
							$blockFile = getLocaleFileName( $SITE_LOCATION . '/design/blocks/' . $blockName . '/' . $blockName, $_SESSION['locale'], '.tpl');
						 	if( file_exists( $blockFile) ) {

								//load block data:
							  	$blockData = loadData( $blockName, 'block');
								if( $hasAlias) {
									$blocks[ $blockAliasName] = $blockFile;
									$dataCollector['block'][ $blockAliasName] = $blockData;
								} else {
									$blocks[ $blockName] = $blockFile;
									$dataCollector['block'][ $blockName] = $blockData;
								}
							}

						}
					}
					
					//names of block, to be loaded in templates
				  	$this->smarty->assign('blocks', $blocks);

					//======= LOAD TEMPLATE ======
					/*
					$templateName = $site[CSM_DEFAULT_TEMPLATE];
					if( isset( $cdef['template']) && !empty( $cdef['template']) ) {
						$templateName = $cdef['template'];
					}*/
					$templateFile = getLocaleFileName( $SITE_LOCATION . '/design/templates/' . $templateName . '/' . $templateName, $_SESSION['locale'], '.tpl');
					$this->smarty->display( $templateFile);
					break;

				case SINGLE_BLOCK:				//LOAD A SINGLE BLOCK:
				
				  	$this->smarty->assign('data', $dataCollector);
				
					//BLOCKS
					if( isset( $cdef['blocks']) && !empty( $cdef['blocks']) ) {
						
						$mainBlockFile = null;
						
						foreach( $cdef['blocks'] as $blockName) {

							$blockNameParts = explode( '>>>', $blockName);
							$blockName = $blockNameParts[0];
							
							$blockFile = getLocaleFileName( $SITE_LOCATION . '/design/blocks/' . $blockName . '/' . $blockName, $_SESSION['locale'], '.tpl');
						 	if( file_exists( $blockFile) ) {

								if( !isset( $mainBlockFile)) {
									$mainBlockFile = $blockFile;
								}

								if( 2 === count( $blockNameParts)) {
									//we have a psudonim:
									$blockName = $blockNameParts[1]; 
								}
								$blocks[ $blockName] = $blockFile;
							}
							
							$blocks[ $blockName] = $blockFile;
						}
				  		$this->smarty->assign('blocks', $blocks);
						
						$this->smarty->display( $mainBlockFile);
					}
				
				/*
					if( isset( $cdef['blocks']) && !empty( $cdef['blocks']) ) {
						$blockName = $cdef['blocks'][0];
						$blockFile = getLocaleFileName( $SITE_LOCATION . '/design/blocks/' . $blockName . '/' . $blockName, $_SESSION['locale'], '.tpl');
						$this->smarty->display( $blockFile);
					}*/
					break;

				case RAW:
					//return action data in JSON format.
					echo json_encode( $dataCollector['raw'] );
					break;

				default:
					echo 'response type error';
					break;
			}  
			
		}
		
		
		//helper method for things like the Email module to allow to retrieve specific rendered template content
		function returnTemplateContent( $templatePath, $templateName, $templateData) {
			
			//hmmm, need to combine all data from '$dataCollector' (environment data etc)
			global $dataCollector;
			$templateData = array_merge_recursive( $dataCollector, $templateData);
			
		  	$this->smarty->assign('data', $templateData);
			$templateFile = getLocaleFileName( $templatePath . $templateName, $_SESSION['locale'], '.tpl');
			return $this->smarty->fetch( $templateFile);
		}


		function setSessionLocale( $locale) {
			$_SESSION['locale'] = $locale;
		}

		function loadSite( $site, $siteDirectory, $relativeSitePath) {
			//the ability to return content from another site into current site,
			//so that: http://example.com/social/blog but the content for the blog is return from another site.
		}

	}


//	========================================================================================
//	========================================================================================
//	========================================================================================


	function contentigoGo() {
		global $contentigo;
		$contentigo = new Contentigo();
		$contentigo->go();
		exit;
	}
	
	//strips characters that break parsing ( \t\n\r)
	function cleanJSONString( $jsonString) {
		$illegalChars = array("\t", "\n", "\r");
		$cleanJSON = str_replace( $illegalChars, "", $jsonString);
		return $cleanJSON;
	}

	//starts by looking for the global and works towards to most localized
	//returns an array of paths
	//perfect for resources like css and javascript
	function getAllLocaleFileNames( $fileNamePrefix, $localeString, $fileNameSuffix) {
		
		//echo $fileNamePrefix . ' ' . $localeString;
		/*
			start:
			
			foo.css
			foo_en.css
			foo_en-GB.css
			foo_en-GB-london.css
		*/

		$paths = array();

		//first check for a global locale:
		$testFilename = $fileNamePrefix . $fileNameSuffix;
		//echo $testFilename;
	 	if( file_exists( $testFilename) ) {
	 		//great, found a global file:
	 		array_push( $paths, $testFilename);
	 	}

		if( empty( $localeString) ) {
			//locale string part is empty, no point continuing:
			return $paths;
		}

		if( false === stripos( $localeString, '-') ) {
			//we only have a single locale part:
			$testFilename = $fileNamePrefix . '_' . $localeString . $fileNameSuffix;
			//echo '<br>SINGLE: ' . $testFilename . '<br>';
		 	if( file_exists( $testFilename) ) {
		 		//great, found a global file:
		 		array_push( $paths, $testFilename);
		 	}

			return $paths;
		}
		
		$localStringPaths = explode( '-', $localeString);
		//$accumulator = $localStringPaths[0];
		$accumulator = '';

		for ( $i = 0, $max = sizeof( $localStringPaths); $i < $max; $i++) {

			if( 0 == $i) {
				$accumulator = $accumulator . $localStringPaths[ $i];
			} else {
				$accumulator = $accumulator . '-' . $localStringPaths[ $i];
			}
			
			$testFilename = $fileNamePrefix . '_' . $accumulator . $fileNameSuffix;
			//echo '<br>' . $testFilename . '<br>';
		 	if( file_exists( $testFilename) ) {
		 		//great, found a global file:
		 		array_push( $paths, $testFilename);
		 	}

		}
		
		return $paths;		
	}
	
	//returns the name of a file, looks for more and more general 'locales' until file is found.
	//returns false if no suitable file is found
	//locale strings are case-insensitive: "en-US" is the same as "en-us"
	function getLocaleFileName( $fileNamePrefix, $localeString, $fileNameSuffix) {

		if( empty( $localeString) ) {
			//ignore localization and return 'global' file:
			return $fileNamePrefix . $fileNameSuffix;
		}
		
		/*
			"en_GB_london"
			"en_GB"
			"en"
			""
		*/
		
		$testFilename = $fileNamePrefix . '_' . $localeString . $fileNameSuffix;
		//echo 'START: '. $localeString . '<br>';
		
	 	if( !file_exists( $testFilename) ) {
			//file does not exist, search for locale ancestors:

			$testLocalString = $localeString;
			$keepGoing = true;
			
			//	"en_gb_london"
			while( $keepGoing) {
				$positionOfLastUnderscore = strripos( $testLocalString, '-');
				//echo $positionOfLastUnderscore . '<br>';
						
				if( false === $positionOfLastUnderscore) {
					//there is no underscore - we have no more parts:
					// "en"
					$keepGoing = false;
				} else {
					
					$testLocalString = substr( $testLocalString, 0, $positionOfLastUnderscore);
					//echo $testLocalString . '<br>';
				}

				$testFilename = $fileNamePrefix . '_' . $testLocalString . $fileNameSuffix;
				//echo $testFilename . '<br>';
			 	if( file_exists( $testFilename) ) {
			 		//great, found a suitable file:
			 		return $testFilename;
			 	}
			}

			//now check for a 'global' locale "foo.txt":
			$testFilename = $fileNamePrefix . $fileNameSuffix;
		 	if( file_exists( $testFilename) ) {
		 		//great, found a globally (unlocalized) file:
		 		return $testFilename;
		 	}
			
	 	} else {
	 		return $testFilename;
	 	}
	}
 
 
 	//loads block data
 	function loadBlock( $blockName, &$dataCollector, &$cdef) {
		global $SITE_LOCATION;
		global $site;

		$blockNameParts = explode( '>>>', $blockName);
		$blockName = $blockNameParts[0];
		
		$blockDataFile = getLocaleFileName( $SITE_LOCATION . '/content/block_content/' . $blockName . '/' . $blockName, $_SESSION['locale'], '.txt');
		
	 	if( !file_exists( $blockDataFile) ) {
			//block data file does not exist
	 	} else {
	 		$blockJSONData = file_get_contents( $blockDataFile);
	 		$blockViewData = json_decode( cleanJSONString( $blockJSONData), true);
		  	
			if( 2 === count( $blockNameParts)) {
				//we have a psudonim:
				$blockName = $blockNameParts[1]; 
			}
		  	//$dataCollector['block'][ $blockName] = $blockViewData;
		  	$dataCollector['view'] = array_merge( $dataCollector['view'], $blockViewData);
	 	}

 	}	

 	//loads template data and block view
 	function loadTemplate( $blockName) {
 	}	

 	
 	//first looks for module under site, if not found looks for a system module in contentigo
	function loadModule( $moduleName) {
		
		global $modules;
		
		if( isset( $modules[ $moduleName]) ) {
			//should probably check the stored value is an instance of module etc:
			return $modules[ $moduleName];
		}

		global $SITE_LOCATION;
		$moduleLocation = $SITE_LOCATION . '/modules/' . $moduleName . '/' . $moduleName . '.php';
		if( !file_exists($moduleLocation) ) {
			//good, look in site first, then in contentigo second.
			global $CONTENTIGO_HOME;
			//now look for module under contentigo module (built-in module):
			$moduleLocation = $CONTENTIGO_HOME . '/modules/' . $moduleName . '/' . $moduleName . '.php';
			if( !file_exists($moduleLocation) ) {
				return false;
			}		
		}

		if( empty( $modules) ) {
			//only need to do this the first time we load a module:
			global $CONTENTIGO_HOME;
			require_once( $CONTENTIGO_HOME . '/system/Module.php');
		}

		require_once( $moduleLocation);
		$module = new $moduleName;
		
		$module->module_init();
		
		$modules[$moduleName] = $module;
		return $modules[$moduleName];
	}

	function saveData( $dataName, $locale, $context, $data) {
		global $SITE_LOCATION;
		global $site;
		//$site['DEFAULT_LOCALE'] = 'es';	//HACK!
		$dataFile = getLocaleFileName( $SITE_LOCATION . '/content/' . $context . '_content/' . $dataName . '/' . $dataName, $_SESSION['locale'], '.txt');
		return file_put_contents( $dataFile, $data);
	}

	function loadJSONDataFile( $jsonDataFile, $assoc = true) {
		$JSONData = file_get_contents( $jsonDataFile);
		return json_decode( cleanJSONString( $JSONData), $assoc);
	}
	
	//could take a third argument to decode to array or object
	function loadData( $dataName, $context = 'application') {
		global $SITE_LOCATION;
		global $site;
		$data = null;
		//$site['DEFAULT_LOCALE'] = 'es';	//HACK!
		$dataFile = getLocaleFileName( $SITE_LOCATION . '/content/' . $context . '_content/' . $dataName . '/' . $dataName, $_SESSION['locale'], '.txt');
//		echo $dataFile; 
	 	if( !file_exists( $dataFile) ) {
			//site data file does not exist
	 	} else {

			if( isset( $site[CSM_CONTENT_CACHING]) && $site[CSM_CONTENT_CACHING] ) {
				//if content caching enabled
				$data = getCacheData( $dataFile);
				if( false === $data) {
		 			//no cache data found, read source data file, then cache it
			 		$JSONData = file_get_contents( $dataFile);
			 		$data = json_decode( cleanJSONString( $JSONData), true);
			 		if( !empty( $data) ) {
			 			//great parsed successfully, now cache the file for next time:
			 			createCacheDataFile( $dataFile, $data);
			 		} else {
			 			//problem parsing json data file
			 		}
		 		}
		 		
			} else {
				//always read from source data file (even if cache file exists):
		 		$JSONData = file_get_contents( $dataFile);
		 		$data = json_decode( cleanJSONString( $JSONData), true);
			}

	 		
	 	}
	 	return $data;
	}
	
	function callAction( $site, $actionName, $pathParts, &$dataCollector, &$cdef, $requestPath) {

		global $SITE_LOCATION;
		global $CONTENTIGO_HOME;

		$actionFound = false;
		
		$actionFileName = $SITE_LOCATION . '/actions/' . $actionName . '.php';
		if( file_exists( $actionFileName) ) {
			//great
			$actionFound = true;
		} else {
			//look in system actions:
			$actionFileName = $CONTENTIGO_HOME . '/actions/' . $actionName . '.php';
			if( file_exists( $actionFileName) ) {
				//great, action not found in user site, but found in system:
				$actionFound = true;
			}
		}

		if( $actionFound) {
			
			require_once( $CONTENTIGO_HOME . '/actions/Action.php');
			
			require_once( $actionFileName);
			$action = new $actionName;

			if( !$action->isAuthorised() ) {
				//hmmm, this would prevent any subsequent actions from running...
				//could possibly change this to simply return 'false'
				header('HTTP/1.0 403 Forbidden');
				print('<html><body>HTTP 403 - Forbidden</body></html>');
				exit;
			}

			if( $action->isSynchronized() ) {
				//need to check if there is a synchronization lock file in place:
				if( actionIsLocked( $actionName) ) {
					//do not execute the action:
					return false;
				} else {
					//lock the action now
					lockAction( $actionName); 
				}
			}

			try {
				$actionResponse = $action->performAction( $pathParts, $dataCollector, $requestPath);
			} catch (Exception $e) {
    			//handle the exception, but continue with normal flow
    			logMessage( $e->getMessage() );
			}

			if( $action->isSynchronized() ) {
				//allow action to run again:
				unlockAction( $actionName);
			}

			if( isset( $actionResponse) && isset( $actionResponse['response']) && !empty($actionResponse['response']) ) {
				//great, we've got an action response
				
				//TODO: depricate this - shouldn't put data in the response object.
				if( isset( $actionResponse['data']) && !empty( $actionResponse['data'] ) ) {
					$dataCollector['action'][ $actionName] = $actionResponse['data'];
				}
				
				if( isset( $site[CSM_ACTION_RESPONSE_MAP][ $actionName]) && isset($site[CSM_ACTION_RESPONSE_MAP][ $actionName][ $actionResponse['response']]) ){

					$actionCDEF = $site[CSM_ACTION_RESPONSE_MAP][ $actionName][ $actionResponse['response']];
	
					if( isset( $actionCDEF['template']) && !empty( $actionCDEF['template'] ) ) {
						$cdef['template'] = $actionCDEF['template'];

						//also, go back to 'TEMPLATE_BLOCKS' and load all blocks for this template...
						/*
						if( isset( $site['TEMPLATE_BLOCKS'][ $cdef['template'] ] ) && !empty( $site['TEMPLATE_BLOCKS'][ $cdef['template'] ] ) ) {
							foreach( $site['TEMPLATE_BLOCKS'][ $cdef['template']] as $blockName) {
								array_push( $cdef['blocks'], $blockName);
								loadBlock( $blockName, $dataCollector, $cdef);
							}
						}*/
						
					}
	
					if( isset( $actionCDEF['blocks']) && !empty( $actionCDEF['blocks'] ) ) {
						if( isset( $cdef['blocks']) && !empty( $cdef['blocks'] ) ) {
							$cdef['blocks'] = array_merge( $actionCDEF['blocks'], $cdef['blocks']);
						} else {
							$cdef['blocks'] = $actionCDEF['blocks'];
						}
					}

				} else {
					//this action response does not have a mapped content definition....
					
					//no problem.
				}
				
			}
	
		}
		
		return true;
	}
	

	function loadValidator( $validatorClassName) {
		//$validatorClassName = $this->getValidatorName( $fieldType);
		global $CONTENTIGO_HOME;
		require_once( "$CONTENTIGO_HOME/system/FieldValidator.php");
		
		global $SITE_LOCATION;
		require_once( $SITE_LOCATION . "/field_validators/$validatorClassName.php");

		$validator = new $validatorClassName;
		return $validator;
	}

	
// logging and debugging

function debugVarDump( &$var, $thenExit) {
	global $site;
	if( isset( $site[CSM_DEBUG]) && $site[CSM_DEBUG]) {
		echo var_dump( $var);
		if( $thenExit) {
			exit;
		}
	}
}


function logVar( $var) {
	trigger_error( var_export( $var, true) , E_USER_NOTICE);
}

function logMessage( $message) {
	trigger_error( $message , E_USER_NOTICE);
}

function readfile_chunked($filename,$retbytes=true) {
   $chunksize = 1 * (1024 * 1024); // how many bytes per chunk
   $buffer = '';
   $cnt =0;
   $handle = fopen($filename, 'rb');
   if ($handle === false) {
       return false;
   }
   while( !feof( $handle) ) {
       $buffer = fread($handle, $chunksize);
       echo $buffer;
       ob_flush();
       flush();
       if ($retbytes) {
           $cnt += strlen($buffer);
       }
   }
       $status = fclose($handle);
   if ($retbytes && $status) {
       return $cnt; // return num. bytes delivered like readfile() does.
   }
   return $status;

} 

// ============= UTILITY CACHING FUNCTIONS =============
function isCached( $context, $dataName, $cacheKey) {
	//check cache expiry
	return false;
}
// eg cacheRetrieve( 'fiestas', 'sorted-by-date')
function cacheRetrieve( $context, $dataName, $cacheKey) {
	//check cache expiry
	return false;
}
// eg cachePut( 'application', 'fiestas', 'sorted-by-date', array('hours' => 2) )
function cachePut( $context, $dataName, $cacheKey, $data, $expires = false) {
	// if( !$expires) { cache forever!}
	//serialsize $data to PHP native format
}
function cacheEmpty( $context, $dataName, $cacheKey) {
	//delete any cached files - contentigo-admin should use this when content is updated.
}

// ============= DATA FILE CACHING FUNCTIONS =============

//returns true on success, false if file not found, or delete unsuccessful, or is caching disabled
function deleteCacheData( $dataFile) {
	
	$cacheDatafileInfo = getCacheDataFile( $dataFile);
	if( false === $cacheDatafileInfo) {
		//cache file does not exist:
		return false;
	}
	return unlink( $cacheDatafileInfo['complete_filepath']);
}

//false return if data file not found or if existing cache is corrupt/invalid (thus, forces a re-compilation of invalid cache file) 
function getCacheData( $dataFile) {
	
	$cacheDatafileInfo = getCacheDataFile( $dataFile);
	if( false === $cacheDatafileInfo) {
		return false;
	}
	$data = unserialize(file_get_contents( $cacheDatafileInfo['complete_filepath'] ));
	return $data;
}


function getCacheDataFile( $dataFile) {
	if( !file_exists( $dataFile) ) {
		return false;
	}
	
	/* 
		IF:	C:/GTO_EUROPE/eclipse-workspace/local/public_html/licor43.es/gto/site/content/application_content/concursos/concursos_es.txt
		RETURN: C:/GTO_EUROPE/eclipse-workspace/local/public_html/licor43.es/gto/site/content/application_content/concursos/.cache/concursos_es.txt.php
	*/
	$response = array();
	$response['cache_subdirectory_name'] = '.cache';
	
	$positionOfLastSlash = strrpos( $dataFile, '/');
	$filePrefix = substr( $dataFile, 0, $positionOfLastSlash + 1);
	$fileSuffix = substr( $dataFile, $positionOfLastSlash + 1);
	$cacheDataFile = $filePrefix . $response['cache_subdirectory_name'] . '/' . $fileSuffix . '.cache';
	
	$response['path'] = $filePrefix;
	$response['filename'] = $fileSuffix;
	$response['complete_filepath'] = $cacheDataFile;
	
	return $response;
}

function createCacheDataFile( $dataFile, $data) {
	$cacheDataFileInfo = getCacheDataFile( $dataFile);
	mkdir( $cacheDataFileInfo['path'] . $cacheDataFileInfo['cache_subdirectory_name'], 0755);
	$serializedData = serialize( $data);
	file_put_contents( $cacheDataFileInfo['complete_filepath'], $serializedData);
}
// ============= CACHING FUNCTIONS =============

function outputFile( $resourceFileName, $mimeType = null) {
	if( null !== $mimeType) {
		header('Content-type: ' . $mimeType);
	}
	header('Content-Length: ' . filesize( $resourceFileName) );
	header('Content-Transfer-Encoding: binary');
	header('Last-Modified: ' . gmdate('D, d M Y H:i:s', filemtime($resourceFileName)) . ' GMT');
	readfile_chunked( $resourceFileName);
}

// ============== ACTION SYNCHRONIZATION FUCTIONS ==============
function actionIsLocked( $actionName) {
	//look for a .actionName file in the '_locks/' dir
	global $SITE_LOCATION;
	$actionLockFile = $SITE_LOCATION . '/_locks/' . $actionName . '.lock';
	if( file_exists( $actionLockFile) ) {
		return true;
	}
	return false;
}

function lockAction( $actionName) {
	global $SITE_LOCATION;
	$actionLockDirectory = $SITE_LOCATION . '/_locks/';
	$actionLockFile = $actionLockDirectory . $actionName . '.lock';
	//$actionMonitorFile = $actionLockDirectory . $actionName . '.monitor';
	if( !file_exists( $actionLockFile) ) {
		//ensure lock directory exists:
		if( !file_exists( $actionLockDirectory) ) {
			mkdir( $actionLockDirectory, 0755);
		}
		$handle = fopen( $actionLockFile, 'a');
		//$handle = fopen( $actionMonitorFile, 'a');
		fclose( $handle);
	}

	//confirm file has been created:
	if( file_exists( $actionLockFile) ) {
		return true;
	}
	return false;
}

function unlockAction( $actionName) {
	global $SITE_LOCATION;
	$actionLockFile = $SITE_LOCATION . '/_locks/' . $actionName . '.lock';
	//$actionMonitorFile = $SITE_LOCATION . '/_locks/' . $actionName . '.monitor';
	if( file_exists( $actionLockFile) ) {
		$deleteLockFileSuccess = unlink( $actionLockFile);
		//$deleteMonitorFileSuccess = unlink( $actionMonitorFile);

		//delete this if there proves to be no problems with deleting lock files:
		if( false === $deleteLockFileSuccess) {
			//1st attempt error - eek dangerous - try again:
			$deleteLockFileSuccess = unlink( $actionLockFile);
			if( false === $deleteLockFileSuccess) {
				//2nd attempt error - eek dangerous - try again:
				$deleteLockFileSuccess = unlink( $actionLockFile);
				if( false === $deleteLockFileSuccess) {
					//3rd attempt error - eek dangerous - try again:
					$errorSubject = 'Contentigo Alert: failed to delete lock';
					$errorMessage = 'failed deleting lock file of action: ' . $actionName . ' file: ' . $actionLockFile;
					$emailModule = loadModule('Email');
					$emailModule->sendPlainMail( 'tcarnell@gmail.com', 'alerts@femtoo.com', $errorSubject, $errorMessage);
					return false;
				}
			}
		}
		
	}
	return true;
}
// ============== END ACTION SYNCHRONIZATION FUCTIONS ==============


//============== BASIC HELPER FUNCTIONS ==============

//values get trimmed by default
//returns value if value is present
//also standardizes behaviour for the php addslashes behaviour
//changed to handle when parameters are arrays and return $valueIfNotFound if array is empty 
function requestParam( $paramName, $valueIfNotFound = null) {
	if( array_key_exists($paramName, $_REQUEST) && isset( $_REQUEST[ $paramName] ) ) {
		
		if( is_array( $_REQUEST[ $paramName])) {
			
			if( count( $_REQUEST[ $paramName]) > 0) {
				return $_REQUEST[ $paramName];
			}
			
		} elseif( strlen($_REQUEST[ $paramName]) > 0) {
			$paramValue = null;
			if( get_magic_quotes_gpc() ) {
				$paramValue = stripslashes( $_REQUEST[$paramName] );
			} else {
				$paramValue = $_REQUEST[$paramName];
			}
			return trim( $paramValue);
		}
		
	}
	return $valueIfNotFound;
}

function requestParamExists( $paramName, $checkIsNotZeroLength = true) {
	if( array_key_exists($paramName, $_REQUEST) ) {
		if( $checkIsNotZeroLength) {
			if( strlen( $paramName) > 0) {
				return true;				
			}	
		} else {
			return true;
		}
	}
	return false;
}

function booleanRequestParam( $paramName, $valueForTrue) {
	$paramValue = requestParam( $paramName, null);
	if( isset( $paramValue) && $paramValue == $valueForTrue) {
		return true;
	}
	return false;
}

//if paramName exists in REQUEST and is !empty '$valueIfPresent' is returned, otherwise
//$valueIfAbscent is returned
function existsRequestParam( $paramName, $valueIfPresent = true, $valueIfAbscent = false) {
	if( array_key_exists( $paramName, $_REQUEST) && !empty( $_REQUEST[$paramName]) ) {
		return $valueIfPresent;
	}
	return $valueIfAbscent;
}

//============== END BASIC HELPER FUNCTIONS ==============


//============== SECURITY: AUTHERIZATION AND AUTHENTICATION ==============

//redirects if required, does nothing otherwise
function doRedirectOnAutherization() {
	
	global $site;
	//after calling actions, check if we were redirected to get authenticated:
	if( array_key_exists( CSM_AUTHENTICATION, $site) ) {
		if( isset( $site[CSM_AUTHENTICATION]['AUTHENTICATION_REDIRECT_FLAG_KEY']) ) {
			$redirectFlag = $site[CSM_AUTHENTICATION]['AUTHENTICATION_REDIRECT_FLAG_KEY'];
			if( isset( $_SESSION[ $redirectFlag]) && true === $_SESSION[ $redirectFlag] ) {

				//yes, session has been redirected, so we need to redirect AGAIN to original url:
	
				$redirectRetryURL = $_SESSION[ $site[CSM_AUTHENTICATION]['AUTHENTICATION_REDIRECT_URL_KEY'] ];
				$redirectURLData = $_SESSION[ $site[CSM_AUTHENTICATION]['AUTHENTICATION_REDIRECT_DATA_KEY'] ];
				
				if( isset( $redirectURLData) && !empty( $redirectURLData) ) {
					$redirectRetryURL .= '?' . http_build_query( $redirectURLData);
				}
				$_SESSION[ $site[CSM_AUTHENTICATION]['AUTHENTICATION_REDIRECT_FLAG_KEY'] ] = false;
	
				unset( $_SESSION[ $site[CSM_AUTHENTICATION]['AUTHENTICATION_REDIRECT_URL_KEY'] ] );
				unset( $_SESSION[ $site[CSM_AUTHENTICATION]['AUTHENTICATION_REDIRECT_DATA_KEY'] ] );
	
				header('Location: ' . $redirectRetryURL);
				exit;
			}
		}
	}
}
//============== END SECURITY: AUTHERIZATION AND AUTHENTICATION ==============

?>
